package CholeskyExpansion;


import com.sun.corba.se.spi.activation._ServerManagerImplBase;
import sun.management.resources.agent_ko;

import javax.swing.*;
import javax.swing.plaf.basic.BasicBorders;

public class Solver
{
    public Matrix Solve(Matrix A,Matrix B)
    {
        Matrix[] tmp = CholeskyExpansion(A);
        Matrix T  = tmp[0];
        Matrix Tt = tmp[1];
        Matrix y = getResolveFromT(T, B);
        return getResolve(Tt,y);
    }

    Matrix getResolve(Matrix A, Matrix B)
    {
        double[][] dataA = A.getValues();
        double[][] dataB = B.getValues();
        double[][] X     = new double[dataA.length][1];
        int n = dataA.length - 1;

        X[n][0] = dataB[n][0]/dataA[n][0];

        for(int line = n; line >= 0; line--)
        {
            double sum = 0;
            for(int column = n; column > line; column--)
            {
                sum += X[column][0]*dataA[line][column];
            }
            X[line][0] = (dataB[line][0] - sum)/dataA[line][line];
        }

        return new Matrix(X);
    }

    Matrix getResolveFromT(Matrix A, Matrix B)
    {
        double[][] dataA = A.getValues();
        double[][] dataB = B.getValues();
        double[][] X  = new double[dataA.length][1];

        X[0][0] = dataB[0][0]/dataA[0][0];

        for(int line = 1; line < X.length; line++)
        {
            double sum = 0;
            for(int column = 0; column < line; column++)
            {
                sum += X[column][0]*dataA[line][column];
            }
            X[line][0] = (dataB[line][0]-sum)/dataA[line][line];
        }

        return new Matrix(X);
    }

    Matrix[] CholeskyExpansion(Matrix A)
    {
        double[][] data = A.getValues();
        double[][] Ldata = new double[data.length][data[0].length];

        for(int line_index = 0; line_index < data.length; line_index++)
        {
            for(int column_index = 0; column_index < line_index; column_index++)
            {
                double sum = 0;
                for(int i = 0; i < column_index ; i++)
                    sum += Ldata[line_index][i]*Ldata[column_index][i];
                Ldata[line_index][column_index] = (1/Ldata[column_index][column_index])*(data[line_index][column_index]-sum);
            }

            double sum = 0;
            for(int i = 0;i < line_index; i++ )
            {
                sum += Math.pow(Ldata[line_index][i],2);
            }
            double underSqrt = data[line_index][line_index] - sum;
            Ldata[line_index][line_index] = Math.sqrt(underSqrt);
        }

        Matrix LMatrix = new Matrix(Ldata);
        return new Matrix[]{LMatrix, LMatrix.getTransposeMatrix()};
    }
}
