package OLS;
import OLS.SetEquSolver.*;
public class Approximator
{

    final static double precision = Math.pow(10,-5);
    FuncBasis myBasis;
/*
    private Matrix F;
    private Matrix FT;
 */
    double[] xs;
    double[] ys;

    public Approximator(FuncBasis basis,double[] xs,double[] ys)
    {
        myBasis = basis;
 //       fillF_FT(xs,basis.getLen());
        this.xs = xs;
        this.ys = ys;
    }

    public FuncBasis getBasis()
    {
        return myBasis;
    }

    public double[] getFactors()
    {
        Matrix Factors;
        Matrix InfMatrix;
        Matrix FreeMember;
        Solver mySetSolver = new SolveGauss();

        InfMatrix = fillInf();
        FreeMember = fillFreeMember(ys);

        Factors = mySetSolver.Solve(InfMatrix, FreeMember, precision);
        double[][] data = Factors.getValues();
        double[] ret = new double[data.length];
        for (int i = 0; i < data.length; i++)
            ret[i] = data[i][0];

        return ret;
    }

 /*   void fillF_FT(double[] xs, int func_count)
    {
        double[][] data = new double[xs.length][func_count];
        int line_index, column_index;
        for(line_index = 0;line_index < xs.length; line_index++)
            for(column_index = 0; column_index < func_count; column_index++)
                data[line_index][column_index] = myBasis.getFuncValue(column_index,xs[line_index]);

        F = new Matrix(data);
        FT = F.getTransposeMatrix();
        return;
    }
 */

    double[][] getGramm(double []xs, int func_count)
    {
        double[][] data = new double[func_count][func_count];
        int line_index,column_index;
        for(line_index = 0; line_index < func_count;line_index++)         // TODO
            for (column_index=0; column_index < func_count;column_index++)
            {
                double sum = 0;
                for(int i = 0; i < xs.length;i++)
                    sum += myBasis.getFuncValue(line_index,xs[i])*myBasis.getFuncValue(column_index,xs[i]);
                data[line_index][column_index] = sum;
            }

        return data;
    }

    Matrix fillInf()
    {
        return new Matrix(getGramm(xs,myBasis.getLen()));
    }

    Matrix fillFreeMember(double[] ys)
    {
        /*
        double[][] data = new double[ys.length][1];
        for(int i = 0; i < data.length; i++)
            data[i][0] = ys[i];
        return Matrix.Multiply(FT,new Matrix(data));
        */

        double[][] data = new double[myBasis.getLen()][1];
        for(int line_index = 0; line_index < myBasis.getLen(); line_index++)
        {
            double sum = 0;
            for(int i = 0; i < ys.length; i++)
                sum += ys[i]*myBasis.getFuncValue(line_index,xs[i]);
            data[line_index][0] = sum;
        }

        return new Matrix(data);
    }
}
